--- callerid.c.orig     2013-03-28 18:09:55.000000000 -0500
+++ callerid.c  2013-03-28 18:35:11.000000000 -0500
@@ -189,9 +189,12 @@
 void callerid_get(struct callerid_state *cid, char **name, char **number, int *flags)
 {
        *flags = cid->flags;
-       if (cid->flags & (CID_UNKNOWN_NAME | CID_PRIVATE_NAME))
-               *name = NULL;
+       if (cid->flags & CID_UNKNOWN_NAME)
+           *name = "Unknown Name";
        else
+           if (cid->flags & CID_PRIVATE_NAME)
+               *name = "Private Caller";
+           else
                *name = cid->name;
        if (cid->flags & (CID_UNKNOWN_NUMBER | CID_PRIVATE_NUMBER))
                *number = NULL;
@@ -557,7 +560,9 @@
        memcpy(buf, cid->oldstuff, cid->oldlen);
        mylen += cid->oldlen/2;

-       for (x = 0; x < len; x++)
+        ast_log(LOG_DEBUG, "CallerID Feed Start (%d) [%s]\n", mylen, cid->rawdata);
+
+       for (x = 0; x < len; x++)
                buf[x+cid->oldlen/2] = AST_XLAW(ubuf[x]);
        while (mylen >= 160) {
                olen = mylen;
@@ -624,8 +629,8 @@
                                if (b != (256 - (cid->cksum & 0xff))) {
                                        ast_log(LOG_NOTICE, "Caller*ID failed checksum\n");
                                        /* Try again */
-                                       cid->sawflag = 0;
-                                       break;
+                                       /* cid->sawflag = 0; In fact there is no way to try again.....*/
+                                       /* break;            Let's try to use the CID we got.  It would be nice to pass some flag out.*/
                                }

                                cid->number[0] = '\0';
